*** COS 2018 11, last update 2022 11  
           
program define dq_con_rv1, rclass  
syntax varlist(numeric) [if] [in], [ststrata(string) metadatafile(int 0) nomod(int 0)  breakreport(int 0) indent(int 0)]  
marksample touse, novarlist  
						     
local indent=`indent'+5  
local adoname "dq_con_rv1"  
local text_i "di as text _n "  					  
global rv1_hlc 				"$rv1_hlc_PE_1"	  
global rv1_slc 				"$rv1_slc_PE_1"	  
global rv1_lim_hl 			"$limit_inadm_low_1"  
global rv1_lim_hu  			"$limit_inadm_up_1"  
global rv1_lim_sl  			"$limit_uncertain_low_1"  
global rv1_lim_su  			"$limit_uncertain_up_1"  
local limittypes 			"lim_hl_ lim_hu_ lim_sl_ lim_su_"		  
local lim_hl_label "$limit_inadm_low_1"  
local lim_hu_label "$limit_inadm_up_1"  
local lim_sl_label "$limit_uncertain_low_1"  
local lim_su_label "$limit_uncertain_up_1"  
* Locals use for creation of new scalars  
local	lim_hl_ hl_  
local	lim_sl_ sl_  
local	lim_hu_ hu_  
local	lim_su_ su_  
	          
	          
foreach var of varlist `varlist' {  
	          
	local pointer "$`var'"         							  
	local vt_number="vtnum_`pointer'"						  
	          
	*global limitlines$`pointer' ""							  
	local  hardlimit=0										  
	local  softlimit=0										  
	qui count if `touse' &`var'<.  
	local Nall=r(N)											  
	          
	          
	if `metadatafile'==1 {  
			scalar rv1_slc_PE_`ststrata'_`pointer'=0		  
			scalar rv1_hlc_PE_`ststrata'_`pointer'=0		  
			scalar rv1_slc_NU_`ststrata'_`pointer'=0		  
			scalar rv1_hlc_NU_`ststrata'_`pointer'=0		  
			foreach limit of local limittypes {				  
				capture confirm scalar `limit'$`pointer'  
				if _rc==0 {																												  
					if "`=`limit'$`pointer''"~="" {  
						local limitnumber=real(subinstr(subinstr(subinstr("`=`limit'$`pointer''","<","",.),"=","",.),">","",.))			  
						scalar rv1_`limit'`ststrata'_`pointer'=`limitnumber'															  
						     
						tempvar changevar																								  
						qui gen `changevar'=m`var'																						  
						tempvar refvar																									  
						qui gen `refvar'=m`var'								  
						     
						qui capture replace `changevar' =. if `touse' & m`var' `=`limit'$`pointer''  & m`var'<.								  
						if _rc>0 {																										  
							dq_out_add ,  tablename(integtable_metadata) row(integtablerows_metadata) columns(3) ///  
										colcontent1("$Warning_1") colcontent2("`var': `=`limit'$`pointer''") colcontent3(``limit'label': $corruptlogic_issue_3)  indent(`indent') 	  
						}    
						     
						else 	{																										  
							qui count if `touse' & `refvar'<.																			  
							local countref=r(N)  
							qui count if `touse' & `changevar'<.																		  
							local countnew=r(N)							  
							local changecount=`countref'-`countnew'  
							    
							if `nomod'<2 & strpos("`limit'","_s")>0 {  
								scalar changerv_`ststrata'_`pointer'=changerv_`ststrata'_`pointer'+`changecount' 						  
								qui replace m`var'=`changevar'																			  
								   
							}   
							    
							if `nomod'<3 & strpos("`limit'","_h")>0 {  
								scalar changerv_`ststrata'_`pointer'=changerv_`ststrata'_`pointer'+`changecount' 						  
								qui replace m`var'=`changevar'																			  
							}   
							    
							*drop auxilliary variables  
							drop `refvar'  
							drop `changevar'  
														  
							*** Create DQ indicator scalars  
							scalar rv1_``limit''NU_`ststrata'_`pointer'=`changecount'														  
							capture scalar rv1_``limit''PE_`ststrata'_`pointer'=`changecount'/vp_N_`ststrata'_`pointer'					  
								if _rc>0 scalar rv1_``limit''PE_`ststrata'_`pointer' =""													  
							    
							if strpos("`limit'","_h")>0	 {																				  
								scalar rv1_hlc_PE_`ststrata'_`pointer'=rv1_hlc_PE_`ststrata'_`pointer'+`changecount'/`Nall'*100			  
								scalar rv1_hlc_NU_`ststrata'_`pointer'=rv1_hlc_NU_`ststrata'_`pointer'+`changecount'					  
								local  hardlimit=1																						  
								local limitname "rv1_hlc_PE_`ststrata'_`pointer'"  
							}   
							if strpos("`limit'","_s")>0	  {																				  
								scalar rv1_slc_PE_`ststrata'_`pointer'=rv1_slc_PE_`ststrata'_`pointer'+`changecount'/`Nall'*100			  
								scalar rv1_slc_NU_`ststrata'_`pointer'=rv1_slc_NU_`ststrata'_`pointer'+`changecount'					  
								local  softlimit=1																						  
								local limitname "rv1_slc_PE_`ststrata'_`pointer'"  
							}   
							}   
					}     
				}      
			}       
			        
		if `hardlimit'==0 {  
			scalar drop rv1_hlc_PE_`ststrata'_`pointer'	  
			scalar drop rv1_hlc_NU_`ststrata'_`pointer'	  
		}        
		if `softlimit'==0{  
			scalar drop rv1_slc_PE_`ststrata'_`pointer'	  
			scalar drop rv1_slc_NU_`ststrata'_`pointer'	  
		}        
		         
	}         
	          
} 	        
		         
end        
