*** COS 2018 12, last update 2022 01  
           
program define dq_hlp_syn  
syntax ,[ indent(int 0)]  
local indent=`indent'+5  
local adoname "dq_hlp_syn"  
local text_i "di as text _n "  					  
*** Globals for syntax list - should be identical to list in the call dq_reportcall - to be included in dq sub programs  
global syntax_datasource_files																				///  
			/// DATA SOURCE AND FOLDERS																		///  
			/// Source directory for target study data files 												///  
			[sd(string)]																					///  
			/// Directory for help files to conduct data quality reports									///  
			[hd(string)]																					///  
			/// Name of the xlsx file that contains the data quality grades									///  
			[gradingfile(string)]																			///  
			/// Directory for log files																		///  
			[ld(string)]																					///  
			/// Source directory of metadata files															///  
			[sdmd(string)]																					///			  
			/// Result directory 																			///  
			[rd(string)]																					///  
			///Result data directory	- for modified individual level study data set						///  
			[rdd(string)]																					///			  
			/// Scalar result data directory - for data quality assessment results							///  
			[srdd(string)]																					///		  
			/// Data quality report target directory														///  
			[dqrd(string)]																					///  
			/// Directory for graphical results																///  
			[gd(string)]																					///  
			/// Directory for graphical thumbs results														///  
			[gdth(string)]																					///  
			/// Directory for graphical dq results															///  
			[gddq(string)]																					///  
			/// Study Data file names																		///  
			[targetfiles(string)]																			///	  
			/// Metadata file name	 - Optional																///  
			[metadatafile(string)]																			///					  
			/// Interpretationtext file name	 - Optional													///  
			[interpretationtextfile(string)]																///  
			/// Reference name for automatically created subgroup name										///  
			[subgroupreference(string)]																		///  
			/// Whether to change variable names to lower letters or not, Default yes=1, no=0				///  
			[lowercase(int 1)]																				///  
			/// How to organize results in directory														///  
			[subgroupfolder(int 0)]																	  
			        
global syntax_variablelists																					///  
			/// Primary variables for checking 																///	  
			[keyvars(string)] 																				///  
			/// Minorvars are variable that are not in a key role 								 			///  
			[minorvars(string) ] 																			///			  
			/// Processvars are processvariables related to the process of the measurements		 			///  
			[processvars(string) ] 																			///			  
			/// Controll variables are variables used to control in regression analyses			 			///  
			[controlvars(string) ] 																			///			  
			/// Auxilliary variables Observer (obs), Device (dev), Time (time)	 				 			///  
			[observervars(string) devicevars(string) centervars(string) timevars(string)]					///			  
			/// ID Variables																	 			///  
			[idvars(string) ] 																				///  
			/// List of variables indicating participation variables 										///  
			[casemissvars(string) ] 																		///  
			/// Define the type of missing indicator variable												///  
			[casemisstype(string) ] 																		///  
			/// Defines the logic to identify complete cases												///  
			[casemisslogic(string)]																				  
			        
global syntax_reportformatting																				///  
			/// Report name to be used as storage of files (recommended no blans)							///  
			[reportname(string)]																			///				  
			/// Segment name 																				///  
			[segmentname(string)] 																			///			  
			/// Included segments																			///  
			[segmentselect(string)] 																		///	  
			/// Excluded segments																			///  
			[segmentexclude(string)] 																		///  
			/// Select variables for report																	///  
			[varselect(string)] 																			///			  
			/// Title of the report to be displayed as the header of the report								///  
			[reporttitle(string)]																			///			  
			/// Subitle of the report to be displayed as the header of the report							///  
			[reportsubtitle(string)]																		///	  
			/// pdf vs. docx 																				///  
			[reportformat(string)]																			///  
			/// Report template to output conent															///  
			[reporttemplate(string)]																		///  
			/// Replace an existing report, 0=no, 1 all, 2 only pdf											///  
			[replacereport(int 0)]																			///			  
			/// Report Authors 																				///  
			[authors(string)]																				///  
			/// Maximum length of variable labels for better display 										///  
			[maxvarlabellength (int 40)]																	///  
			/// Output for interpretation part 																///  
			[view_interpretation(int 1)]																	///  
			/// Output for data integrity overview 															///  
			[view_integrity(int 1)] 																		///  
			/// Output for data quality indicator results overview											///  
			[view_dqi(int 1)] 																				///  
			/// Output for change logs																		///  
			[view_changelog(int 1)] 																		///  
			/// Number of categories up to which a display takes place as histogram 						///  
			[histkat (int 11)]																				///  
			/// Whether or not a page break is conducted after each variable 0=no 1 = yes 					///  
			[varlinebreak(int 1)]																			///  
			/// Whether or not a page break occurs after each table  0=no 1 = yes 							///  
			[sectionlinebreak(int 1)] 																		///  
			/// Number of lines required for a table to accept a pagebreak afterwards						///  
			[linenumberpagebreak(int 7)] 																	///  
			/// Colorassignement for colorpalettes															///  
			[clustercolorpalettes(string)] 																	///  
			/// Requests maximum number of decimals for erport					 							///  
			[decimals(int 2)] 																				///			  
			/// Language setting																			///  
			[language (string)]																				///																		  
			/// Modify width of graphs					 													///  
			[widthadd(int 0)] 																				///  
			/// Modify height of graphs					 													///  
			[heightadd(int 0)]  
			        
global syntax_textformatting																				///  
			/// Warncolor: The color of text in case of warning issues										///  
			[warncolor(string)]																								  
			        
global syntax_analysissettings																				///  
			/// Whether or not new calculations are forced even if there is existing output 				///  
			[forcecalc(int 0)]																				///  
			/// Defines a subgroup														 					///  
			[subgroup(string)]																				///			  
			/// Recodes NAs from R to Missing DOCU														 	///  
			[Rmissrecode(int 0)]																			///  
			/// The minimum proportion of values that need to be succesfully converted to real 			 	///  
			[recodeminprop(real .95)]																		///  
			/// Whether or not an allowed jump should be recoded to reference category (Default no recode) 	///  
			[jumpto0recode(int 0)]																			///  
			/// Provide a user made Missing list for recodings 										 		///  
			[itemmisslist(string)]																			///  
			/// Provide a user made jump list for recodings 												///  
			[itemjumplist(string)]																			///				  
			/// List of potential outlier checks to be performed											///  
			[outcheck(int 1)] 																				///		  
			/// Adjustment for the sensitivity which which outlier checks are performed						///  
			[outsens(int 1)] 																				///	  
			/// The way in which results from different checks are integrated								///  
			[outintegrate(int 1)] 																			///	  
			/// Number of levels up to which a categorical variable is recoded to  binary 					///  
			[binaryrecodelimit (int 8) ]																	///  
			/// Number of levels after which a variable is regarded as ratio/interval if no metadata		///  
			[metriclevels (int 25) ]																		///  
			/// Minium N to compute a report																///  
			[minreportn(int 30)]																			///  
			/// Minium size of a cluster for inclusion in ICC analyses										///  
			[minclustersize_icc(int 10)]																	///  
			/// Minium size of a cluster for inclusion in Lowess  analyses									///  
			[minclustersize_lowess(int 40)]																	///  
			/// Minium number of events for calcualtions in lowess											///  
			[minevent_lowess(int 2)]																		///  
			/// Create a 2nd round for a report with all variables identified as problematic (Default0=no) 	///  
			[problemvarreport(int 0)]																		///	  
			/// Minimum number of variables to conduct a report - to avoid nuisance reports				 	///  
			[minvarnum(int 1)]																				///  
			/// Request a benchmark report across different single reportstop							 	///  
			[benchmark(int 0)]																				///  
			/// No modification option to suppress variable modifications due to range violations /ev	 	///  
			[nomod]																							///  
			/// Default compression supressed to assess the original data types							 	///  
			[nocompress]	  
			        
global multiresultreporting																					///  
			/// Create reports from all loaded results 0= no 1 =yes 										///	  
			[resultreport(int 0)] 																			///	  
			/// Defines the variable to be used for multiresult reporting									///	  
			[rr_ordervar(string)]																	  
global check_settings																						///  
			/// The number of expected data records in the final analysis file 			HOTFIX treating subgroups must be solved					///	  
			[totalrecordnumber(int )] 	  
			        
global technical_settings																					///  
			/// Defines the structural object, on which analyses are performed								///  
			[structure(string) ]																			///				  
			/// Defines the stratum only																	///  
			[ststrata(string) ]																				///  
			/// Defines the cluster only																	///  
			[stcluster(string) ]		  
			        
global syntax_debugging																						///  
			/// Wether or not additional output is displayed for debugging in the log						///  
			[]																			///  
			/// Wether or not calculations are terminated in case of severe variable issues  				///  
			[breakreport(int 0)]																			///  
			/// Indent for better help output												  				///  
			[indent(int 0)]  
end        
